﻿# -*- coding: utf_8 -*-
import shared
import pygame

from otherfunction import *
from res import *
import sys, types, thread, threading, time
import playingInfo

import sys
if sys.platform == "win32": import win32process

sliderDraging	= threading.Event()
songPlayEvent	= threading.Event()
songStopEvent	= threading.Event()
songLooperCond	= atomCondition()

def init():
	shared.event = pygame.event
	pygame.mixer.pre_init(44100,-16,2,4096)#smaller than 1536 might result in choppy play
	#pygame.init()
	pygame.display.init()#minimal require for event system operation
	# pygame.event.set_blocked(pygame.VIDEOEXPOSE)
	pygame.mixer.init()
	# pygame.mixer.set_num_channels(1)
	pygame.mixer.set_reserved(0)
	# shared.channel = pygame.mixer.find_channel()
	shared.channel = pygame.mixer.Channel(0)
	shared.channel.set_endevent(shared.EVENT_SOUNDEND)
	thread.start_new_thread(eventTaker, ())

def sliderDragingUpdate(value):
	if shared.programExit.isSet(): return
	cur_offset	= value*shared.playingInfo.blockSize
	curSec	= cur_offset/(44100*4)
	fullLengthSec = shared.playingInfo.curMagicTable["fullLength"] / (44100 * 4)
	if cur_offset < shared.playingInfo.curMagicTable["introLength"]: symbol = unicode("→", 'utf_8')
	else: symbol = unicode("∞", 'utf_8')
	shared.songStatus.SetLabel("%s/%s %s" %
		 (secToStr(curSec,2), secToStr(fullLengthSec,2), symbol))	
	
def sliderUpdate(input):
	if shared.programExit.isSet(): return
	playedLength	= input[0]
	cur_offset	= input[1]
	introLength	= shared.playingInfo.curMagicTable["introLength"]
	fullLength	= shared.playingInfo.curMagicTable["fullLength"]
	playedSec	= playedLength/(44100*4)
	fullLengthSec = fullLength/(44100*4)
	loopLengthSec	= (fullLength-introLength)/(44100*4)
	curSec	= (cur_offset/(44100*4))%fullLengthSec
	if cur_offset < introLength: symbol = unicode("→", 'utf_8')
	else: symbol = unicode("∞", 'utf_8')
	if shared.playingInfo.repeatPlaying.isSet():
		shared.songStatus.SetLabel("%s/%s %s" %
			 (secToStr(curSec,2), secToStr(fullLengthSec,2), symbol))	
	else:
		# shared.songStatus.SetLabel("(%s)%%(%s+%s*%i)=%s|%s %s" %
			 # (secToStr(playedSec,2), secToStr(fullLengthSec,2), secToStr(loopLengthSec,2), shared.playingInfo.loopPlayTimes, secToStr(curSec,2), secToStr(fullLengthSec,2), symbol))
		shared.songStatus.SetLabel("(%s)%%(%s)=%s|%s %s" %
			(secToStr(playedSec,2), secToStr(fullLengthSec+loopLengthSec*shared.playingInfo.loopPlayTimes,2), secToStr(curSec,2), secToStr(fullLengthSec,2), symbol))
	shared.slider.SetValue(cur_offset / shared.playingInfo.blockSize)
	shared.slider.Refresh()

def songLooper(dict, Pos = 0):
	playedLength = 0L
	soundInfoQueue = []

	# if sys.platform == "win32":
		# win32process.SetPriorityClass(win32process.GetCurrentProcess(), win32process.HIGH_PRIORITY_CLASS)
		
	blockSize   = shared.playingInfo.blockSize
	if Pos is 0: cur_offset  = 0
	else:
		cur_offset = Pos*blockSize
		playedLength += cur_offset
	filePath	= dict["filePath"]
	magicTable	= dict["magicTable"]
	fileOffset  = magicTable["fileOffset"]
	introLength	= magicTable["introLength"]
	fileLength  = magicTable["fullLength"]
	fileEndOffset	= fileOffset+fileLength
	fileFadeOutStartOffset = fileEndOffset
	firstLoop	= True
	fadingOutRound	= 0
	loopPlayedTimes	= 0
	fadeSecs	= 11
	# if shared.playingInfo.loopPlayTimes == 0:
		# fileFadeOutStartOffset	= fileEndOffset-fadeSecs*44100*4
	# else: fileFadeOutStartOffset = fileEndOffset
	shared.channel.set_volume(1)
	fadeMethod	= 2

	#slider init
	if shared.programExit.isSet() is False:
		shared.slider.ClearTicks()
		shared.slider.SetRange(0, fileLength / blockSize)
		if sys.platform == "win32":
			shared.slider.SetTickFreq(fileLength / blockSize)
			shared.slider.SetTick(introLength / blockSize)
		shared.event.post(shared.event.Event(shared.EVENT_INFOUPD, {"Ctl":"SliderUPD", "Pos":(cur_offset,cur_offset)}))
	while True:
		soundInfoQueue.append((playedLength,cur_offset))
		readLength	= 0
		if fileOffset+cur_offset<fileEndOffset-fadeSecs*44100*4:
			if shared.playingInfo.repeatPlaying.isSet() is False and loopPlayedTimes >= shared.playingInfo.loopPlayTimes:
				if fileFadeOutStartOffset != fileEndOffset-fadeSecs*44100*4:
					fileFadeOutStartOffset = fileEndOffset-fadeSecs*44100*4
			else:
				if fileFadeOutStartOffset != fileEndOffset:
					fileFadeOutStartOffset = fileEndOffset
				
		if cur_offset+blockSize*2 > fileLength:
			readLength  = fileLength-cur_offset
			tempSound   = pygame.mixer.Sound(waveFileLikeObj(filePath, fileOffset+cur_offset, readLength, fileFadeOutStartOffset, fadeSecs, fadeMethod))
			cur_offset  = introLength
			
			if shared.playingInfo.repeatPlaying.isSet() and fadingOutRound == 0 or loopPlayedTimes < shared.playingInfo.loopPlayTimes:
				if fileFadeOutStartOffset != fileEndOffset:
					cur_offset	= 0
					playedLength	= -readLength
				fadingOutRound	= 0
				if shared.playingInfo.repeatPlaying.isSet() and fadingOutRound == 0:
					loopPlayedTimes	= 0
			elif fileFadeOutStartOffset == fileEndOffset-fadeSecs*44100*4:
				fadingOutRound	= 1
			loopPlayedTimes += 1
		elif fadingOutRound == 0:
			readLength  = blockSize
			tempSound   = pygame.mixer.Sound(waveFileLikeObj(filePath, fileOffset+cur_offset, readLength, fileFadeOutStartOffset, fadeSecs, fadeMethod))
			cur_offset  += blockSize
		playedLength += readLength

		if firstLoop is True:
			if songPlayEvent.isSet() is False:
				shared.channel.play(tempSound)
				songPlayEvent.set()
			else:
				shared.channel.queue(tempSound)
				firstLoop = False
		else:
			shared.event.post(shared.event.Event(shared.EVENT_INFOUPD, {"Ctl":"SliderUPD", "Pos":(soundInfoQueue.pop(0))}))
			songLooperCond.wait()
			# if fadingOutRound is 3: # 1+(1play+1queue)
				# while shared.channel.get_busy() == 1: 
					# pass
			if songStopEvent.isSet():
				shared.channel.stop()
				songPlayEvent.clear()
				songStopEvent.clear()
				songLooperCond.ack()
				return 
			elif fadingOutRound <= 1:
				shared.channel.queue(tempSound)
				songLooperCond.ack()
			else:
				songLooperCond.ack()
			if fadingOutRound >= 3: shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Next"}))
			if fadingOutRound is not 0: fadingOutRound += 1
					
def setAtStatus(status):
	if shared.programExit.isSet(): return
	if status is "Play":
		shared.toolBar.ToggleTool(ID_CTL_PLAY, True)
		shared.slider.Enable(True)
		shared.songChoiceCtl.Enable(True)
		shared.toolBar.EnableTool(ID_CTL_PAUSE, True)
		shared.toolBar.EnableTool(ID_CTL_PREV, True)
		shared.toolBar.EnableTool(ID_CTL_NEXT, True)
	elif status is "Pause":
		shared.toolBar.ToggleTool(ID_CTL_PAUSE, True)
		shared.slider.Enable(False)
		shared.songChoiceCtl.Enable(False)
		shared.toolBar.EnableTool(ID_CTL_PREV, False)
		shared.toolBar.EnableTool(ID_CTL_NEXT, False)
	elif status is "Stop":
		shared.toolBar.ToggleTool(ID_CTL_STOP, True)
		shared.slider.Enable(False)
		shared.songChoiceCtl.Enable(True)
		shared.toolBar.EnableTool(ID_CTL_PAUSE, False)
		shared.toolBar.EnableTool(ID_CTL_PREV, True)
		shared.toolBar.EnableTool(ID_CTL_NEXT, True)

def eventTaker():
	curStatus = "Stop"
	playFiniteState	= {"Play":0, "Pause":0, "Stop":0}
	# if sys.platform == "win32":
		# win32process.SetPriorityClass(win32process.GetCurrentProcess(), win32process.HIGH_PRIORITY_CLASS)
	while True:
		cur_event = pygame.event.wait()
		if cur_event is None:
			break
		elif cur_event.type is pygame.QUIT:
			shared.eventTakerQuit.set()
			break
		elif cur_event.type is shared.EVENT_INFOUPD:
			if cur_event.Ctl is "SliderUPD":
				if sliderDraging.isSet() is False:
					sliderUpdate(cur_event.Pos)
			elif cur_event.Ctl is "SetPlayingOrder":
				shared.playingInfo.setCurPlayOrderByRes(cur_event.evnId)
				if shared.playingInfo.repeatPlaying.isSet():
					shared.toolBar.EnableTool(ID_CTL_LOOPINC, False)
					shared.toolBar.EnableTool(ID_CTL_LOOPDEC, False)
				else:
					shared.toolBar.EnableTool(ID_CTL_LOOPINC, True)
					shared.toolBar.EnableTool(ID_CTL_LOOPDEC, True)
		elif cur_event.type is shared.EVENT_FRAMEUPD:
			if cur_event.Ctl is "Init":
				shared.toolBar.ToggleTool(ID_ORDER_REPEAT, True)
				shared.playingInfo.repeatPlaying.set()
				shared.toolBar.ToggleTool(ID_CTL_STOP, True)
				shared.toolBar.EnableTool(ID_CTL_STOP, False)
				shared.toolBar.EnableTool(ID_CTL_PAUSE, False)
				shared.toolBar.EnableTool(ID_CTL_PLAY, False)
				shared.toolBar.EnableTool(ID_CTL_PREV, False)
				shared.toolBar.EnableTool(ID_CTL_NEXT, False)
				for curKey in shared.thBGMdata.seriesKeyList:
					if shared.pref.getboolean("thBGMsel", curKey) != None: 
						shared.toolBar.ToggleTool(shared.thBGMdata.keyToResTable[curKey], shared.playingInfo.userEnableSeries(curKey, shared.pref.getboolean("thBGMsel", curKey)))
				if shared.pref.get("thBGMsetting", "playingOrder") != None:
					res = shared.playingInfo.playingOrderKeyToRes[shared.pref.get("thBGMsetting", "playingOrder")]
					shared.toolBar.ToggleTool(res, True)
					shared.playingInfo.setCurPlayOrderByRes(res)
				if shared.pref.getint("thBGMsetting", "loopPlayTimes") != None:
					shared.playingInfo.loopPlayTimes = shared.pref.getint("thBGMsetting", "loopPlayTimes")
				shared.event.post(shared.event.Event(shared.EVENT_FRAMEUPD, {"Ctl":"UpdateSelTHBGM"}))
			elif cur_event.Ctl is "UpdateSelTHBGM":
				shared.playingInfo.updateSongChoiceCtl()
				if shared.playingInfo.isPlayable():
					shared.songChoiceCtl.Enable(True)
					shared.toolBar.EnableTool(ID_CTL_STOP, True)
					shared.toolBar.EnableTool(ID_CTL_PLAY, True)
					shared.toolBar.EnableTool(ID_CTL_PREV, True)
					shared.toolBar.EnableTool(ID_CTL_NEXT, True)
					setAtStatus(curStatus)
				else:
					shared.songChoiceCtl.Enable(False)
					shared.toolBar.EnableTool(ID_CTL_STOP, False)
					shared.toolBar.EnableTool(ID_CTL_PAUSE, False)
					shared.toolBar.EnableTool(ID_CTL_PLAY, False)
					shared.toolBar.EnableTool(ID_CTL_PREV, False)
					shared.toolBar.EnableTool(ID_CTL_NEXT, False)
		elif cur_event.type is shared.EVENT_SOUNDCTL:
			FailedState = False
			if curStatus is "Play":
				if cur_event.Ctl is "Play":
					songStopEvent.set()
					songLooperCond.notify()
					pygame.event.clear(shared.EVENT_INFOUPD)
					pygame.event.clear(shared.EVENT_SOUNDEND) #there will be an evnSoundEnd in queue after stop channel/sound
					if hasattr(cur_event, "Pos"):
						thread.start_new_thread(songLooper, (playingInfo.getLooperInput(), cur_event.Pos))
					else:
						thread.start_new_thread(songLooper, (playingInfo.getLooperInput(),))
					songPlayEvent.wait()
				elif cur_event.Ctl is "Pause":
					shared.channel.pause()
				elif cur_event.Ctl is "Stop":
					songStopEvent.set()
					songLooperCond.notify()
					if shared.programExit.isSet() is False: sliderUpdate((0,0))
				elif cur_event.Ctl is "Next":
					playingInfo.selNextTrack()
					shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Play"}))
				elif cur_event.Ctl is "Prev":
					playingInfo.selPrevTrack()
					shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Play"}))
				elif cur_event.Ctl is "Scrolling":
					sliderDraging.set()
					sliderDragingUpdate(cur_event.Pos)
				elif cur_event.Ctl is "Scroll":
					sliderDraging.clear()
					shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Play", "Pos":cur_event.Pos}))
				elif cur_event.Ctl is "Choice":
					if shared.playingInfo.setCurPlaySongByChoiceIdx(cur_event.idx):
						shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Play"}))
				else:
					FailedState = True
			elif curStatus is "Pause":
				if cur_event.Ctl is "Play":
					shared.channel.unpause()
				elif cur_event.Ctl is "Stop":
					songStopEvent.set()
					songLooperCond.notify()
				else:
					FailedState = True
			elif curStatus is "Stop":
				if cur_event.Ctl is "Play":
					pygame.event.clear(shared.EVENT_INFOUPD)
					pygame.event.clear(shared.EVENT_SOUNDEND) #there will be an evnSoundEnd in queue after stop channel/sound
					thread.start_new_thread(songLooper, (playingInfo.getLooperInput(),))
					songPlayEvent.wait()
				elif cur_event.Ctl is "Next":
					playingInfo.selNextTrack()
				elif cur_event.Ctl is "Prev":
					playingInfo.selPrevTrack()
				elif cur_event.Ctl is "Choice":
					shared.playingInfo.setCurPlaySongByChoiceIdx(cur_event.idx)
				else:
					FailedState = True
			if playFiniteState.has_key(cur_event.Ctl) and FailedState is False:
				# if curStatus != cur_event.Ctl:
				curStatus = cur_event.Ctl
				setAtStatus(curStatus)
		elif cur_event.type is shared.EVENT_SOUNDEND:
			if curStatus is "Play": songLooperCond.notify()
		else:
			print "exception event"
			print cur_event.type


